SystemOrganization addCategory: #'Tp-TADP'!
SystemOrganization addCategory: #'Tp-TADP-META4'!
SystemOrganization addCategory: #'Tp-TADP-METAP-TEST'!
SystemOrganization addCategory: #'Tp-TADP-Mascotas'!
SystemOrganization addCategory: #'Tp-TADP-Meta1'!
SystemOrganization addCategory: #'Tp-TADP-Test'!

Trait named: #ConPosicion
	uses: {}
	category: 'Tp-TADP'!

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:34'!
coincide: unElemento con: otroElemento
	unElemento = otroElemento ifTrue: [^1]. ^0! !

!ConPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:28'!
cuantosAciertosTiene: unaJugada
	^ self  posiciones inject: 0 into: [:acum :unaPosicion | acum + (self coincide: (unaJugada at: unaPosicion) con: (self ultimaJugadaGanadora at: unaPosicion))] ! !

Trait named: #Poceado
	uses: {}
	category: 'Tp-TADP'!

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:29'!
calculaCantidadDeJugadasConAciertos: numeroDeAciertos
	^ self apuestasEnJuego select: [ :unaApuesta | (self cuantosAciertosTiene: (unaApuesta jugada) ) = numeroDeAciertos ]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:53'!
calculaGanadoresYRepartiPremios
	| primerPremio segundoPremio tercerPremio |
	
	self repartirAAgencias.
	
	primerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion).
	segundoPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 1).
	tercerPremio := self calculaCantidadDeJugadasConAciertos: (self mejorSituacion - 2).
	
	self pagarA: primerPremio  conAciertos: (self mejorSituacion).
	self pagarA: segundoPremio  conAciertos: (self mejorSituacion - 1).
	self pagarA: tercerPremio  conAciertos: (self mejorSituacion - 2).
! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:59'!
mejorSituacion 
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:26'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:06'!
porcentajePara: unNumero
	self requirement! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:16'!
pozo
	^ (self apuestasEnJuego size * self valorDeJugada)
	 ! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:30'!
premioDe: unaJugada
	^ self pozo * (self porcentajePara: (self cuantosAciertosTiene: unaJugada))! !

!Poceado methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:32'!
valorDeJugada 
	self requirement! !

Trait named: #SinPosicion
	uses: {}
	category: 'Tp-TADP'!

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!SinPosicion methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:12'!
siEstaSumaUno: unNumero
	(self ultimaJugadaGanadora includes: unNumero)
		ifTrue: [ ^ 1 ]
		ifFalse: [ ^ 0 ]! !

TestCase subclass: #TestMetaP1
	instanceVariableNames: 'miMascota mascotaDelVecino animalSalvaje'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-METAP-TEST'!

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 16:41'!
animalSalvaje
	^ animalSalvaje! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 16:41'!
animalSalvaje: anObject
	animalSalvaje := anObject! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
mascotaDelVecino
	^ mascotaDelVecino! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
mascotaDelVecino: anObject
	mascotaDelVecino := anObject! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
miMascota
	^ miMascota! !

!TestMetaP1 methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 09:51'!
miMascota: anObject
	miMascota := anObject! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:49'!
setUp
	Mascota compile: (('recibiDanio: unDanio <n> self  energia: energia - unDanio. ') expandMacros).
	Mascota compile: (('atacar: unObjetivo <n> self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 20]. ') expandMacros).
	Mascota compile: (('dormi: unaCantidad <n> self energia: energia + unaCantidad. ') expandMacros).
	Salvaje  compile: (('recibiDanio: unDanio <n> self  energia: energia - unDanio. ') expandMacros).
	Salvaje compile: (('atacar: unObjetivo <n> self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 100]. ') expandMacros).
	Salvaje compile: (('dormi: unaCantidad <n> self energia: energia + unaCantidad. ') expandMacros).
	miMascota  := Mascota nuevoConEnergia: 50.
	mascotaDelVecino  := Mascota nuevoConEnergia: 50.
	animalSalvaje := Salvaje nuevoConEnergia: 50.! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:27'!
testAgregarCodigoAntesDeLosAccesorsDeUnaCategoria
	| refactor accesors |
	refactor := MethodManager new.
	refactor agregarCodigo: '" Accesor de Mascota "' antesDeLosAccesorsDe: 'Tp-TADP-Mascotas'.
	accesors := refactor obtenerAccesorsDe: (mascotaDelVecino class).
	self assert: (accesors allSatisfy: [:each | ((((mascotaDelVecino class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de Mascota "']). ! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
testAgregarCodigoAntesDeLosAccesorsDeUnaListaDeClases
	| refactor accesors |
	refactor := MethodManager new.
	refactor agregarCodigo: '" Accesor de un Animal "' antesDeLosAccesorsDe: {Mascota. Salvaje.}. 
	accesors := refactor obtenerAccesorsDe: (mascotaDelVecino class).
	self assert: (accesors allSatisfy: [:each | ((((mascotaDelVecino class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de un Animal "']). 
	accesors := refactor obtenerAccesorsDe: (animalSalvaje  class).
	self assert: (accesors allSatisfy: [:each | ((((animalSalvaje  class)>>each)getSource )lineNumber: 2) sameAs:  '" Accesor de un Animal "']). ! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:50'!
testAgregarCodigoAntesDeUnMetodoExistenteEnUnaCategoria
	MethodManager new agregarCodigo: ' self estado: Despierto new.' antesDeMetodosQueEmpiezanCon: 'recibiDanio:' en: {Mascota. Salvaje.}. 
	animalSalvaje estado: Dormido new.
	miMascota atacar: animalSalvaje .
	miMascota estado: Dormido new.
	animalSalvaje  atacar: miMascota.
	self assert: miMascota  estado class equals: Despierto.! !

!TestMetaP1 methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 10:35'!
testAgregarCodigoDespuesDeUnMetodoExistenteEnUnaCategoria
	MethodManager new agregarCodigo: ' self estado: Dormido new.' despuesDeMetodosQueEmpiezanCon: 'dormi:' en: 'Tp-TADP-Mascotas'. 
	miMascota dormi: 12.
	miMascota  atacar: mascotaDelVecino.
	self assert: mascotaDelVecino  energia equals: 50. ! !

TestCase subclass: #TestMetap4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-METAP-TEST'!

!TestMetap4 class methodsFor: 'history' stamp: 'MarianoGerman 9/21/2012 13:11'!
lastStoredRun
	^ ((Dictionary new) add: (#errors->((Set new))); add: (#passed->((Set new) add: #testConvertirHerenciaAComp; yourself)); add: (#failures->((Set new))); add: (#timeStamp->(DateAndTime basicNew instVarAt: 1 put: 47458; instVarAt: 2 put: (Duration seconds: -10800 nanoSeconds: 0); instVarAt: 3 put: 2456192; instVarAt: 4 put: 151000000; yourself)); yourself)! !

!TestMetap4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 20:29'!
setUp 

	MetaUtil recreateCategory: 'backUpJuego2'! !

!TestMetap4 methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 20:30'!
testConvertirHerenciaAComp

| juego loto superClaseLoto nuevaSuperClase |
juego:= Juego new.
loto:= Loto new.

ConvHerenciaAComp converti: juego.

superClaseLoto := loto class superclass.
nuevaSuperClase := (juego instVarNamed: 'estiloDeJuego') class.

self halt.
self assert: superClaseLoto asString equals: nuevaSuperClase asString.
! !

TestCase subclass: #TestsGenerales
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

TestCase subclass: #TestsLoto
	instanceVariableNames: 'apuestaLoto agenciaTota juegoLoto jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:23'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	juegoLoto sorteame: #(5 6 7 8).
	
	self assert: agenciaTota caja equals: (2 * 0.12).! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: agenciaTota caja equals: 0.28.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:03'!
testCuantoGanaUnaApuesta
	
	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(4 8 15 16 23 42).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: jugada.
	
	self assert: (juegoLoto premioDe: jugada) equals: 2*0.4.! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:31'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	self assert: (juegoLoto apuestasEnJuego size > 0).
	! !

!TestsLoto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:08'!
testPozo

	agenciaTota := Agencia new.
	juegoLoto := Loto new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2).

	juegoLoto apuesto: jugada en: agenciaTota conMonto: 2.
	
	juegoLoto sorteame: #(8).
	
	self assert: (juegoLoto pozo) equals:  2.! !

TestCase subclass: #TestsPagaOPaga
	instanceVariableNames: 'agenciaTota juegoPagaLPM jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaAgencia

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: agenciaTota caja equals: (337.5 * 0.1).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoPagaLPM sorteame: jugada.
	
	self assert: (juegoPagaLPM premioDe: jugada conMonto: 100 ) equals: (337.5 * 0.7).! !

!TestsPagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:34'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoPagaLPM := PagaOPaga new.
	jugada := OrderedCollection new.

	jugada addAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15).

	juegoPagaLPM apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: juegoPagaLPM apuestasEnJuego size > 0.! !

TestCase subclass: #TestsProde
	instanceVariableNames: 'agenciaGanaRiver juegoProde jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:38'!
testAgenciaGanaFijoPorJugada 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: #(e e e e e e e e e e e e e).
	
	self assert: agenciaGanaRiver caja equals: (5*0.15) ! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:16'!
testCuantoGanaAgencia
	
	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: agenciaGanaRiver caja equals: ((5 * 0.15) + (5 * 0.5 * 0.05))! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:14'!
testCuantoGanaUnaApuesta 

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(l v e l l l l l l l l e e ).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	juegoProde sorteame: jugada.
	
	self assert: (juegoProde premioDe: jugada) equals: (5 * 0.5)! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:37'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaGanaRiver  := Agencia new.
	juegoProde  := Prode new.
	jugada := OrderedCollection new.

	jugada addAll: #(l l l l l l e e e e e v v).

	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: (juegoProde apuestasEnJuego size > 0).
	! !

!TestsProde methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 20:07'!
testPozo

	agenciaGanaRiver := Agencia new.
	juegoProde := Prode new.
	jugada := OrderedCollection new.
	
	jugada addAll: #(1).
	
	juegoProde apuesto: jugada en: agenciaGanaRiver conMonto: 5.
	
	self assert: juegoProde pozo equals: 5.! !

TestCase subclass: #TestsQuini
	instanceVariableNames: 'agenciaTota juegoQuini jugada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Test'!

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testAgenciaGanaFijoPorJugada

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #().
	
	self assert: agenciaTota caja equals: (100 * 0.17)! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:41'!
testCuantoGanaAgencia 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: agenciaTota caja equals: 100 * 0.17.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testCuantoGanaUnaApuesta 

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.
		
	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	juegoQuini sorteame: #(0000 1412 3333 1010 4343 1212 8484 9999 1022 3833 5454 1463 7282 8254 7598 2512 8209 9412 6655 3333).
	
	self assert: (juegoQuini premioDe: jugada conMonto: 100) equals: 3500 * 100.! !

!TestsQuini methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:42'!
testMeteLaApuestaEnColeccionDeApuestas

	agenciaTota := Agencia new.
	juegoQuini := Quiniela new.
	jugada := OrderedCollection new.

	"jugada es: (numero posicion)"

	jugada addAll: #(1412 2).

	juegoQuini apuesto: jugada en: agenciaTota conMonto: 100.
	
	self assert: (juegoQuini apuestasEnJuego size > 0).
	! !

Object subclass: #Agencia
	instanceVariableNames: 'caja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:23'!
caja
	^ caja! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:33'!
caja: anObject
	caja := anObject! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:34'!
ganaste: plata 
	self caja: caja + plata.! !

!Agencia methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 03:42'!
initialize
	self caja: 0! !

Object subclass: #Apuesta
	instanceVariableNames: 'jugada agencia monto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia
	^ agencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
agencia: unaAgencia
	agencia := unaAgencia.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:37'!
jugada 
	^jugada! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:34'!
jugada: unaJugada 
	jugada := unaJugada.! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto 
	^ monto! !

!Apuesta methodsFor: 'accessing' stamp: 'BrunoFischetti 9/11/2012 02:41'!
monto: unMonto
	monto := unMonto! !

Object subclass: #ConvHerenciaAComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-META4'!

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 04:35'!
cambiaPadreDe: unPadre aOtro: nuevoPadre

		unPadre class allSubclasses do: [:unaSubClase | unaSubClase superclass: nuevoPadre class].! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 04:47'!
converti: unPadre

	| estiloDeJuego stringClaseNueva claseNueva nuevoPadre |
	
	estiloDeJuego := self crearVarInst: unPadre.
	
	stringClaseNueva := self crearNuevaClase.
	claseNueva := (Smalltalk allClasses select: [:each | each name = stringClaseNueva]) first.
	
	nuevoPadre := claseNueva new.
	unPadre instVarNamed: estiloDeJuego put: nuevoPadre.
	
	self cambiaPadreDe: unPadre aOtro: nuevoPadre.

! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 03:31'!
crearNuevaClase
  
          | nombreClase |
	     nombreClase := 'JuegoType'.

	    Object subclass: (nombreClase asSymbol)    
	    instanceVariableNames: ''
	    classVariableNames: ''
    	    poolDictionaries: ''
	    category:  'Tp-TADP'.
	 
	   ^nombreClase.! !

!ConvHerenciaAComp class methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/22/2012 02:49'!
crearVarInst: unPadre

	| instancia |
	instancia := 'estiloDeJuego'.
	unPadre class addInstVarNamed: instancia.
	
	^instancia! !

Object subclass: #Estado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

Estado subclass: #Despierto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Despierto methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 09:46'!
puedeAtacar
	^true.! !

Estado subclass: #Dormido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Dormido methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/16/2012 15:42'!
puedeAtacar
	^false.! !

Object subclass: #GeneradorDeCodigo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/20/2012 22:59'!
obtenerCabeceraDe: unMensaje en: unaClase

	^((unaClase  >>unMensaje ) getSource ) lineNumber: 1. ! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/20/2012 23:16'!
obtenerCodigoDe: unMetodo en: unaClase 
	^ (unaClase >> unMetodo) getSource.! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:04'!
obtenerLinea: unaLinea De: unMensaje en: unaClase

	^((unaClase  >>unMensaje ) getSource ) lineNumber: unaLinea. ! !

!GeneradorDeCodigo methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:52'!
obtenerStatementsDe: unMensaje en: unaClase
	|statements arrayDeLineas|
	"metodo := ''.
	2 to: ((unaClase >> unMensaje) getSource ) lineCount  do:[:each | metodo := metodo ,(((unaClase>> unMensaje ) getSource ) lineNumber: each ) ]."
	arrayDeLineas := ((unaClase  >> unMensaje) getSource )lines.
	arrayDeLineas at:1 put: ''.
	statements := arrayDeLineas inject: '' into:[:metodo :each| metodo,'<n>',each].
	^(statements expandMacros ) trimLeft .! !

GeneradorDeCodigo subclass: #PosteriorAlExistente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!PosteriorAlExistente methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 02:28'!
agregarCodigo: codigo alMetodo: unMetodo enLaClase: unaClase 
	|nuevoMensaje clausulaReturn posicionReturn|
	nuevoMensaje := (self obtenerCodigoDe: unMetodo  en: unaClase).
	posicionReturn := nuevoMensaje findString: '^' .
	clausulaReturn := ''.
	(posicionReturn > 0) ifTrue: [clausulaReturn := nuevoMensaje copyFrom:  posicionReturn   to:  nuevoMensaje size.
								  nuevoMensaje := nuevoMensaje copyFrom:  1 to:(posicionReturn-1)].
	nuevoMensaje :=  nuevoMensaje ,'<n>', codigo,'<n>',clausulaReturn.
	unaClase compile:( nuevoMensaje expandMacros).! !

GeneradorDeCodigo subclass: #PrevioAlExistente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!PrevioAlExistente methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:27'!
agregarCodigo: codigo alMetodo: unMetodo enLaClase: unaClase 
	|cabecera statements nuevoMensaje|
	cabecera := self obtenerCabeceraDe: unMetodo  en: unaClase. 
	statements := self obtenerStatementsDe: unMetodo  en: unaClase.
	nuevoMensaje := cabecera,'<n>', codigo ,'<n>', statements .
	unaClase compile: (nuevoMensaje expandMacros).! !

Object subclass: #Juego
	instanceVariableNames: 'apuestasEnJuego ultimaJugadaGanadora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/21/2012 21:13'!
EstiloDeJuego 
  ^EstiloDeJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/21/2012 21:13'!
EstiloDeJuego: nuevaClase 
 EstiloDeJuego:= nuevaClase. ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/21/2012 18:42'!
JuegoStyle 
  ^JuegoStyle. ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:42'!
apuestasEnJuego
	^ apuestasEnJuego.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:30'!
apuesto: unaJugada en: unaAgencia conMonto: unNumero
		| unaApuesta |
	unaApuesta := Apuesta new.
	unaApuesta jugada: unaJugada.
	unaApuesta agencia: unaAgencia.
	unaApuesta monto: unNumero.
	
	self apuestasEnJuego add: unaApuesta.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:49'!
calculaGanadoresYRepartiPremios
	self subclassResponsibility ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'MarianoGerman 9/21/2012 21:13'!
dameNombreMensaje: unMensaje 
  ^(self class selectors) detect:  [:unSelector | unSelector = unMensaje] ifNone: [^nil].! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 			
	apuestasEnJuego := OrderedCollection new.
		
		! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:40'!
repartirAAgencias
	apuestasEnJuego do: [ :unaApuesta | unaApuesta agencia ganaste: (unaApuesta monto * self PorcentajeFijoPorJugada) ]! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:49'!
sorteame: unaJugada
	self ultimaJugadaGanadora: unaJugada.
	self calculaGanadoresYRepartiPremios.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:48'!
ultimaJugadaGanadora
	^ ultimaJugadaGanadora.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:57'!
ultimaJugadaGanadora: jugadaGanadora
	 ultimaJugadaGanadora := jugadaGanadora.! !

Juego subclass: #Loto
	uses: Poceado + SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Loto class
	uses: Poceado classTrait + SinPosicion classTrait
	instanceVariableNames: ''!

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:37'!
PorcentajeFijoPorJugada
	^ 0.12! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 04:09'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:10'!
cuantosAciertosTiene: unaJugada
	^ unaJugada inject: 0 into: [ :acum :unNumero | acum + (self siEstaSumaUno: unNumero) ]! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:43'!
initialize 
	super initialize.! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:43'!
mejorSituacion 
	^ 6! !

!Loto methodsFor: 'accessing' stamp: 'BrunoFischetti 9/14/2012 00:07'!
porcentajePara: unNumero
	unNumero == 6 ifTrue: [^0.4].
	unNumero == 5 ifTrue: [^0.17].
	unNumero == 4 ifTrue: [^0.05].! !

!Loto methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:57'!
valorDeJugada 
	^ 2.! !

Juego subclass: #PagaOPaga
	uses: SinPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeAgenciaGanadora PorcentajeJugadorGanador'
	poolDictionaries: ''
	category: 'Tp-TADP'!

PagaOPaga class
	uses: SinPosicion classTrait
	instanceVariableNames: ''!

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:29'!
PorcentajeAgenciaGanadora
	^ 0.1! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
PorcentajeJugadorGanador
	^ 0.7! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:45'!
calculaGanadoresYRepartiPremios
	self apuestasEnJuego
		do: [ :unaApuesta | 
			unaApuesta agencia
				ganaste: ((self premioDe: unaApuesta jugada conMonto: unaApuesta monto) * self PorcentajeAgenciaGanadora) / self PorcentajeJugadorGanador ]! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!PagaOPaga methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:39'!
premioDe: unaJugada conMonto: unMonto
	^ ((self cuantosAciertosTiene: unaJugada) / 10 raisedTo: 3) * unMonto * self PorcentajeJugadorGanador! !

Juego subclass: #Prode
	uses: Poceado + ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada PorcentajeParaAgenciaGanadora'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Prode class
	uses: Poceado classTrait + ConPosicion classTrait
	instanceVariableNames: ''!

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 19:32'!
PorcentajeFijoPorJugada
	^ 0.15! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:54'!
PorcentajeParaAgenciaGanadora
	^ 0.05! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
mejorSituacion 
	^ 13! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:25'!
pagarA: apuestasGanadoras conAciertos: numeroDeAciertos
	
	self mejorSituacion = numeroDeAciertos ifTrue: [
	
	apuestasGanadoras
		do: [ :apuesta | 
			apuesta agencia
				ganaste: (self pozo * (self porcentajePara: numeroDeAciertos) / apuestasGanadoras size) * self PorcentajeParaAgenciaGanadora]
			
		]! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:50'!
porcentajePara: unNumero
	unNumero == 13 ifTrue: [^0.5].
	unNumero == 12 ifTrue: [^0.35].
	unNumero == 11 ifTrue: [^0.11].! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 23:25'!
posiciones 
	^ #(1 2 3 4 5 6 7 8 9 10 11 12 13)! !

!Prode methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 03:51'!
valorDeJugada 
	^ 5! !

Juego subclass: #Quiniela
	uses: ConPosicion
	instanceVariableNames: ''
	classVariableNames: 'PorcentajeFijoPorJugada'
	poolDictionaries: ''
	category: 'Tp-TADP'!

Quiniela class
	uses: ConPosicion classTrait
	instanceVariableNames: ''!

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/13/2012 23:42'!
PorcentajeFijoPorJugada
	^ 0.17! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
acertoCon: unaJugada
	^ self coincide: (unaJugada first) con: ((self ultimaJugadaGanadora at: unaJugada second) \\ (self porCuantoSeTieneQueDividir: unaJugada first))! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:33'!
calculaGanadoresYRepartiPremios
	
	self repartirAAgencias.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:49'!
cantidadCifrasPara: unNumero
	(unNumero / 1000) >= 1 ifTrue: [^4].
	(unNumero / 100) >= 1 ifTrue: [^3].
	(unNumero / 10) >= 1 ifTrue: [^2].
	^1.
	! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/11/2012 02:44'!
initialize 
	super initialize.! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:44'!
multiplicadorCorrespondienteParaCifrasDe: unaJugada
	| numero |
	numero := self cantidadCifrasPara: (unaJugada first).
	
	numero = 4 ifTrue: [^3500].
	numero = 3 ifTrue: [^500].
	numero = 2 ifTrue: [^70].
	numero = 1 ifTrue: [^7]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 01:06'!
porCuantoSeTieneQueDividir: unNumero
	| numero |
	numero := self cantidadCifrasPara: unNumero. 
	
	numero = 4 ifTrue: [^10000].
	numero = 3 ifTrue: [^1000].
	numero = 2 ifTrue: [^100].
	numero = 1 ifTrue: [^10]! !

!Quiniela methodsFor: 'as yet unclassified' stamp: 'BrunoFischetti 9/14/2012 00:37'!
premioDe: unaJugada conMonto: unMonto
	^ (self multiplicadorCorrespondienteParaCifrasDe: unaJugada) * (unMonto) * ( self acertoCon: unaJugada)! !

Object subclass: #JuegoStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

Object subclass: #JuegoType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!

Object subclass: #Mascota
	instanceVariableNames: 'energia estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Mascota class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:09'!
nuevoConEnergia: unaEnergia 
	|unaMascota|
	unaMascota := self new.
	unaMascota energia: unaEnergia.
	unaMascota estado: Despierto new.
	^unaMascota.! !

!Mascota class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 10:30'!
saluda
	^'hola bruno'.! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
atacar: unObjetivo 
 self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 20]. ! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
dormi: unaCantidad 
 self energia: energia + unaCantidad. ! !

!Mascota methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
energia
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
^ energia! !

!Mascota methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
energia: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
energia := anObject. ! !

!Mascota methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
estado
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "
^ estado! !

!Mascota methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
estado: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
estado := anObject.

" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "

" Accesor de Mascota "! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 09:32'!
prueba: unaPrueba  

! !

!Mascota methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
recibiDanio: unDanio 
 self  energia: energia - unDanio. ! !

Object subclass: #MethodManager
	instanceVariableNames: 'generador estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Meta1'!

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:26'!
agregarCodigo: codigo aLosAccesorsDe: unaClase
	|listaDeAccesors|
	listaDeAccesors := self obtenerAccesorsDe: unaClase.
	listaDeAccesors do:[:each | self generador agregarCodigo: codigo alMetodo: each  enLaClase: unaClase ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:09'!
agregarCodigo: codigo aLosMensajesQueComienzanCon: unaCadena enLaClase: unaClase
	|listaDeMensajes|
	listaDeMensajes := unaClase selectors select:[:each | each asString  beginsWith:  unaCadena]. 
	listaDeMensajes do:[:each | self generador agregarCodigo: codigo alMetodo: each  enLaClase: unaClase ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:25'!
agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena en: clases
	|listaDeClases|
	"Si es un string entonces es una categoria y debo buscar todos sus metodos"
	listaDeClases := self listarClases: clases.
	listaDeClases do: [: each | (self estrategia) value: codigo value: unaCadena value: each ].
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo antesDeLosAccesorsDe: clases
	self generador: PrevioAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosAccesorsDe: cla]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: '' en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo antesDeMetodosQueEmpiezanCon: unaCadena en: clases
	self generador: PrevioAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosMensajesQueComienzanCon: cad enLaClase: cla ]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena  en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo despuesDeLosAccesorsDe: clases
	self generador: PosteriorAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosAccesorsDe: cla]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: '' en: clases.
! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:10'!
agregarCodigo: codigo despuesDeMetodosQueEmpiezanCon: unaCadena en: clases
	self generador: PosteriorAlExistente new.
	self estrategia: ([:cod :cad : cla | self agregarCodigo: cod aLosMensajesQueComienzanCon: cad enLaClase: cla ]).
	self agregarCodigo: codigo aLosMetodosQueEmpiezanCon: unaCadena  en: clases.
! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:15'!
estrategia
^ estrategia! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:14'!
estrategia: anObject
estrategia := anObject! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 01:28'!
generador
^ generador! !

!MethodManager methodsFor: 'accessing' stamp: 'ChristianPisani 9/20/2012 22:50'!
generador: anObject
	generador := anObject! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 10:35'!
listarClases: clases
	|listaDeClases|
	clases isString ifTrue:[ listaDeClases  := (SystemOrganization listAtCategoryNamed: clases)collect: [:each | Smalltalk globals at: each]]
					ifFalse:[listaDeClases := clases].
	^listaDeClases.! !

!MethodManager methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 01:26'!
obtenerAccesorsDe: unaClase
	^unaClase selectors select:[:selector | unaClase instVarNames anySatisfy: [:instVar|(selector asString sameAs: instVar) | (selector asString sameAs: (instVar,':'))]].
	! !

Object subclass: #Salvaje
	instanceVariableNames: 'energia estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP-Mascotas'!

!Salvaje class methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 16:32'!
nuevoConEnergia: unaEnergia 
	|unSalvaje|
	unSalvaje := self new.
	unSalvaje energia: unaEnergia.
	unSalvaje estado: Despierto new.
	^unSalvaje .! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
atacar: unObjetivo 
 self estado puedeAtacar ifTrue:[ unObjetivo recibiDanio: 100]. ! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
dormi: unaCantidad 
 self energia: energia + unaCantidad. ! !

!Salvaje methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
energia
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
^ energia! !

!Salvaje methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
energia: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
energia := anObject! !

!Salvaje methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
estado
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
^ estado! !

!Salvaje methodsFor: 'accessing' stamp: 'ChristianPisani 9/21/2012 17:35'!
estado: anObject
" Accesor de un Animal "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
" Accesor de Mascota "
estado := anObject! !

!Salvaje methodsFor: 'as yet unclassified' stamp: 'ChristianPisani 9/21/2012 17:35'!
recibiDanio: unDanio 
 self  energia: energia - unDanio. ! !

Object subclass: #TipoDeJuego
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp-TADP'!
